"use strict";
var URLSearchParams = require('url').URLSearchParams;
var fetch = require('node-fetch');
var encodedParams = new URLSearchParams();
encodedParams.set('foo', 'bar');
var url = 'https://httpbin.org/anything?foo=bar&foo=baz&baz=abc&key=value';
var options = {
    method: 'POST',
    headers: {
        accept: 'application/json',
        'content-type': 'application/x-www-form-urlencoded',
        cookie: 'foo=bar; bar=baz'
    },
    body: encodedParams
};
fetch(url, options)
    .then(function (res) { return res.json(); })
    .then(function (json) { return console.log(json); })
    .catch(function (err) { return console.error('error:' + err); });
